Dynamic Programming: Minimum # coins required to make change


Dynamic Programming: Minimum # coins required to make change
http://comproguide.blogspot.com/2013/12/minimum-coin-change-problem.html
There are C different denominations of coins/bills in use with values: v 1 < v 2 < ... < v C (So that we can always make change for any amount) You need to pay someone a certain amount of money $N Find the minimum # of coins/bills that you need to use to make the change for $N

First Define sub problems and how to solve original problem with solutions of sub-problems.
Another Solution: http://www.algorithmist.com/index.php/Min-Coin_Change
http://www.fgdsb.com/2015/01/03/coin-change-problem/
nt minCoins(int a[], int n, int t){
    vector<int> dp(t+1,0);
    int minVal;
    for(int i = 1; i <= t; i++){
        minVal = i;
        for (int j = 0; j < n; j++)
            if(a[j] <= i)
                minVal = min(dp[i-a[j]]+1,minVal);
            else
                break;
        dp[i] = minVal;
    }
    return dp[t];
}
C(N,m) = min(C(N,m - 1),C(N - Sm,m) + 1)
with the base cases:
  • C(N,m) = 1,N = 0
  • C(N,m) = 0,N < 0
  • C( N, m ) = 0, N \geq 1, m \leq 0
Define:
    • M(j) = the minimum # coins/bills to make change for   j   (money units)          
How can we:
    • Divide the problem M(j) into smaller subproblems
    • And then use the solution(s) of the smaller problem(s) to solve the original problem M(j
Bottom-up Dynamic programming version

static int findM(int Am, int v[])
    {
       int[] M;
       int[] sol, mySol;
       int j, k, min;

       M = new int[Am+1];              // Store results

       sol = new int[v.length];
       mySol = new int[v.length];

       /* ---------------------------
          Base case
          --------------------------- */
       M[0] = 0;        // 0 coins needed to make change for $0

       /* ---------------------------------------------------
          The other cases (starting from 1 to M.length - 1)

   Follow direction of data flow !
          --------------------------------------------------- */
       for ( j = 1; j <= Am; j++ )
       {
          /* ============================================
      Find min # coin to make change for $j
      ============================================ */

          for ( k = 0; k < v.length; k++ )
             mySol[k] = -1;                   // Initialize mySol[]

          /* --------------------------------------------------------
             Try every denomination k = 1,2,..,C for the last coin
             -------------------------------------------------------- */
          for ( k = 0; k < v.length; k++ )
          {
             /* --------------------------------------------
                Check if we can use the k-th denomination
                -------------------------------------------- */
             if ( v[k] <= j )
             {
                /* ------------------------
                   Divide step
                   ------------------------ */
                sol[k] = M[j - v[k]];     // Use coin v[k] as last coin
                mySol[k] = sol[k] + 1;    // Solution to make change for $j      
             }
          }

          /* --------------------------------------------------------
             Find the minimum of all mySol[...]
             -------------------------------------------------------- */
          M[j] = -1;

          for ( k = 0; k < v.length; k++ )
          {
             if ( mySol[k] > 0 )
             {
                if ( M[j] == -1 || mySol[k] < M[j] )
                   M[j] = mySol[k];
             }
          }
       }

       return( M[Am] );    // Min # coins to change $Am
   }
Dive and Conquer

static int M(int j, int[] v)
    {
       int[] sol, mySol;
       int   myFinalSol;
       int k;

       sol = new int[v.length];
       mySol = new int[v.length];

       /* ---------------------------
          Base cases
          --------------------------- */
       if ( j == 0 )
       {
           return(0);
       }
          
       /* ==================================================
          Initialize mySol[]
   ================================================== */
       for ( k = 0; k < v.length; k++ )
          mySol[k] = -1;                   // -1 means: no solution

       /* --------------------------------------------------------
          Try every denomination k = 1,2,..,C for the last coin
          -------------------------------------------------------- */   
       for ( k = 0; k < v.length; k++ )
       {
          /* --------------------------------------------
             Check if we can use the k-th denomination
             -------------------------------------------- */
          if ( v[k] <= j )
          {
             /* ------------------------
                Divide step
                ------------------------ */
             sol[k] = M(j - v[k], v);  // Use coin v[k] as last coin

             mySol[k] = sol[k] + 1;    // Solution to make change for $j   
          }
       }

       /* --------------------------------------------------------
          Find the minimum for ALL mySol[...] values

   Note: -1 means do NOT use !
          -------------------------------------------------------- */
       myFinalSol = -1;

       for ( k = 0; k < v.length; k++ )
       {
          if ( mySol[k] >= 0 /* Don't use -1 values */ )
          {
             if ( myFinalSol == -1 || mySol[k] < myFinalSol )
                myFinalSol = mySol[k];
          }
       }

       return(myFinalSol);   // Return best solution
   }


Given a value N, if we want to make change for N cents, and we have infinite supply of each of S = { S1, S2, .. , Sm} valued coins, how many ways can we make the change? The order of coins doesn’t matter.
http://n1b-algo.blogspot.com/2009/01/optimal-coin-change-problem.html
https://github.com/n1balgo/algo/blob/master/coin_change.py
def optimal_change(Amt, Currency, Inf):
    # array which contains optimal number of coins required for [0,1,...,Amt] amount
    num_coins = [0] # we need zero coins to give a change of 0 amount
   
    # array which contains the optimal change to reach that amount
    selected_change = [0]
   
    # start with 1 and go till Amt
    for i in xrange(1, Amt+1):
       
        # num_coins required for amount = i
        nc_i = Inf
       
        # selected change for amount = i
        sc_i = Inf
       
        # iter over all coins in the currency
        for c in Currency:
           
            # if c is smaller than required amount and num coins to reach i-c is one less
            # than num coins (nc), then update local variables
            if i >= c and nc_i > num_coins[i-c] + 1:
                nc_i = num_coins[i-c] + 1
                sc_i = c
               
        # update optimal arrays
        num_coins.append(nc_i)
        selected_change.append(sc_i)
       
    # num_coins and selected_change can be used to print the coins required to get optimal change
    return [num_coins, selected_change]

def trace_optimal_solution(Amt, num_coins, selected_change):
    Amt0 = Amt
   
    # coins that are used to make the change for Amt
    coins = {}
   
    nc = num_coins[Amt]
    while nc > 0:
        # get the selected coin
        sc = selected_change[Amt]
       
        # add sc to coin map
        if coins.has_key(sc):
            coins[sc] += 1
        else:
            coins[sc] = 1
           
        # update Amt
        Amt = Amt - sc
       
        # get num coins require to attain Amt
        nc = num_coins[Amt]
   
    print "Optimal soln for", Amt0, "uses", num_coins[Amt0], "coins:", coins
    return coins
   
def greedy_change(Amt, Currency):
    Amt0 = Amt
    num_coins = 0
    coins = {}
   
    # we want to get as much change for max currency first, hence reverse sorting is required
    Currency = sorted(Currency, reverse=True)
   
    for c in Currency:
        # we can pay with c
        if c <= Amt:
           
            # number of c coins to pay
            n = int(Amt/c)
           
            # decrement amount
            Amt = Amt - n * c
           
            # update vars
            num_coins += n
            coins[c] = n
           
    print "Greedy soln for", Amt0, "uses", num_coins, "coins:", coins
    return num_coins
Read full article from Dynamic Programming: Minimum # coins required to make change

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts